SystemOrganization addCategory: #'GT-Examples-Dummies'!
SystemOrganization addCategory: 'GT-Examples-Dummies-Set-1'!
SystemOrganization addCategory: 'GT-Examples-Dummies-Set-2'!
SystemOrganization addCategory: 'GT-Examples-Dummies-Set-3'!
SystemOrganization addCategory: 'GT-Examples-Dummies-Tests'!

Object subclass: #GTDummyExampleProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-2'!

!GTDummyExampleProvider class methodsFor: 'bidirectional-example-linking' stamp: 'StefanReichhart 9/12/2015 18:23'!
gtExamplesProvider
	" Notice: this link is MANDATORY "
	" Usecase: All my examples are implemented on the instance side "
	^ self new! !

!GTDummyExampleProvider class methodsFor: 'bidirectional-example-linking' stamp: 'StefanReichhart 9/12/2015 18:22'!
gtExamplesSource
	" Notice: this link is MANDATORY "
	" Usecase: I'm providing all examples for my source since it is probably a really big one and I implement absolutely nothing but examples (and utilities for examples) "
	^ GTDummyExampleSource! !

!GTDummyExampleProvider methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 18:18'!
a
	<gtExample>
	^ GTDummyExampleSource new a " image this example would do something real about its source "! !

!GTDummyExampleProvider methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 18:18'!
b
	<gtExample>
	^ GTDummyExampleSource new b " image this example would do something real about its source "! !

!GTDummyExampleProvider methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 17:49'!
c: a c: b
	<gtExample>
	<depends: #a>
	<depends: #b>
	^ a | b! !

Object subclass: #GTDummyExampleSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-2'!

!GTDummyExampleSource class methodsFor: 'bidirectional-example-linking' stamp: 'StefanReichhart 9/12/2015 18:23'!
gtExamplesProvider
	" Notice: this link is completely OPTIONAL, but it will provide convenience for browsing examples "
	" Usecase: My provider will implement my examples because I'm probably a class with a lot of methods ... "
	^ GTDummyExampleProvider new! !

!GTDummyExampleSource methodsFor: 'dummy-behaviour' stamp: 'StefanReichhart 9/12/2015 18:17'!
a
	" imagine this would be some real stuff "
	^ true! !

!GTDummyExampleSource methodsFor: 'dummy-behaviour' stamp: 'StefanReichhart 9/12/2015 18:17'!
b
	" imagine this would be some real stuff "
	^ false! !

Object subclass: #GTDummyExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-1'!

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:31'!
a
	<gtExample>
	<label: 'Dummy #a'>
	<description: 'should return true'>
	
	^ true! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:39'!
b: aBoolean
	<gtExample>
	<label: 'Dummy #b:, depends #a'>
	<description: 'should return false'>
	<depends: #a>
	
	^ aBoolean & false! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:39'!
c: aBoolean
	<gtExample>
	<label: 'Dummy #c:, depends #b:'>
	<description: 'should return true'>
	<depends: #b:>
	
	^ aBoolean | true! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:11'!
d: anInteger
	<gtExample>
	<label: 'Dummy #d:, depends #c:'>
	<description: 'should raise an exception as the argument is not anInteger'>
	<depends: #c:>
	<raises: #MessageNotUnderstood>
	
	^ 1 + anInteger! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:11'!
e: aString
	<gtExample>
	<label: 'Dummy #e:, depends #c:'>
	<description: 'should raise an exception as the argument is not aString'>
	<depends: #c:>
	<raises: #Error>
	
	^ 'Hellow World', aString! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:31'!
f: aBoolean
	<gtExample>
	<label: 'Dummy #f:, depends: #c:'>
	<description: 'shouldnt raise any exception'>
	<depends: #c:>
	
	self assert: aBoolean.
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:11'!
g: aBoolean
	<gtExample>
	<label: 'Dummy #g, depends: #c'>
	<description: 'should raise a ZeroDivide'>
	<depends: #c:>
	<raises: #ZeroDivide>
	
	self assert: aBoolean.
	^ 1/0! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 9/26/2015 11:26'!
h: aBoolean
	<gtExample>
	<label: 'Dummy #h, depends: #e:'>
	<description: 'shouldnt raise any exception, but dependency should'>
	<depends: #e:>
	<noTest>
	
	^ aBoolean & false! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:11'!
i
	<gtExample>
	<label: 'Dummy #i'>
	<description: 'should raise ZeroDivide'>

	<raises: #ZeroDivide>
	^ 1/0! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:11'!
j
	<gtExample>
	<label: 'Dummy #j'>
	<description: 'should raise ZeroDivide'>
	<raises: #ZeroDivide>
	<raises: #AssertionFailure>

	1/0.	
	self assert: false! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:36'!
k
	<gtExample>
	<label: 'Dummy #k'>
	<description: 'example with an icon'>
	<icon: #alertIcon>

	^ nil! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:36'!
l
	<gtExample>
! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:37'!
m
	<gtExample>
	<label: 'Dummy #m'>
! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:38'!
n
	<gtExample>
	<label: 'Dummy #n'>
	<description: 'with label and description'>! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:38'!
o
	<gtExample>
	<description: 'with description only'>! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:55'!
p: aBoolean1 p: aBoolean2 p: aBoolean3
	<gtExample>
	<label: 'Dummy #p:p:p:, depends #a, #b:, #c:'>
	<description: 'with description only'>
	<depends: #a>
	<depends: #b:>
	<depends: #c:>
	
	self assert: (aBoolean1 | aBoolean2 | aBoolean3).
	^ aBoolean1 | aBoolean2 | aBoolean3! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:56'!
q: aBoolean
	<gtExample>
	<description: 'with description only'>
	<depends: #p:p:p:>
	
	self assert: aBoolean.
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 11:57'!
r: aBoolean1 r: aBoolean2
	<gtExample>
	<label: 'Dummy #r:, depends #q: and p:p:p:'>
	<depends: #p:p:p:>
	<depends: #q:>
	
	self assert: aBoolean1 & aBoolean2.
	^ aBoolean1 & aBoolean2! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 9/26/2015 11:30'!
s: aBoolean
	<gtExample>
	<label: 'Dummy #s, invalid recursion'>
	<depends: #s:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 9/26/2015 11:31'!
t: aBoolean
	<gtExample>
	<label: 'Dummy #s, invalid recursion'>
	<depends: #s:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 9/26/2015 11:30'!
u: aBoolean
	<gtExample>
	<label: 'Dummy #u, invalid recursion'>
	<depends: #v:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 9/26/2015 11:30'!
v: aBoolean
	<gtExample>
	<label: 'Dummy #v, invalid recursion'>
	<depends: #u:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 9/26/2015 11:30'!
w: aBoolean
	<gtExample>
	<label: 'Dummy #w'>
	<depends: #z:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 9/26/2015 11:30'!
x: aBoolean
	<gtExample>
	<label: 'Dummy #x:, depends: w:'>
	<depends: #w:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 9/26/2015 11:30'!
y: aBoolean1 y: aBoolean2
	<gtExample>
	<label: 'Dummy #y:y:, depends: #x: and #w:'>
	<depends: #x:>
	<depends: #w:>
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamples class methodsFor: 'examples-failing' stamp: 'StefanReichhart 9/26/2015 11:30'!
z: aBoolean
	<gtExample>
	<label: 'Dummy #z, depends: #y:y:'>
	<depends: #y:y:>
	<noTest>
	
	^ aBoolean! !

Object subclass: #GTDummyExamplesInvalid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-1'!

!GTDummyExamplesInvalid class methodsFor: 'examples' stamp: 'StefanReichhart 9/26/2015 11:27'!
a: anObject
	<gtExample>
	<label: 'Dummy #a:'>
	<description: 'argument defined / dependency missing'>
	<noTest>! !

!GTDummyExamplesInvalid class methodsFor: 'examples' stamp: 'StefanReichhart 9/26/2015 11:27'!
b
	<gtExample>
	<label: 'Dummy #b'>
	<description: 'existing dependency defined / argument missing'>
	<depends: #a>
	<noTest>
	! !

!GTDummyExamplesInvalid class methodsFor: 'examples' stamp: 'StefanReichhart 9/26/2015 11:27'!
c: anObject1 c: anObject2
	<gtExample>
	<label: 'Dummy #c:c:'>
	<description: 'non-existing dependencies defined, all arguments defined'>
	<depends: #a>
	<depends: #b:>
	<noTest>
	! !

!GTDummyExamplesInvalid class methodsFor: 'examples' stamp: 'StefanReichhart 9/26/2015 11:27'!
d
	<gtExample>
	<label: 'Dummy #c:c:'>
	<description: 'non-existing dependencies defined, all arguments missing'>
	<depends: #a>
	<depends: #b:>
	<noTest>
	! !

Object subclass: #GTDummyExamplesPragmas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-1'!

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:37'!
a
	<gtExample>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:38'!
b
	<gtExample>
	<label: 'Dummy #b with a label'>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:39'!
c
	<gtExample>
	<description: 'Dummy #c without label but with a description'>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:38'!
d
	<gtExample>
	<label: 'Dummy #d'>
	<description: 'Dummy #d with label and description'>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:43'!
e
	<gtExample>
	<label: 'Dummy #e'>
	<description: 'Dummy #e with an icon (default behaviour)'>
	<icon: #pageIcon>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:43'!
f
	<gtExample>
	<label: 'Dummy #f'>
	<description: 'Dummy #f with an icon provided by the current theme'>
	<iconThemeSelector: #refreshIcon>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:41'!
g
	<gtExample>
	<label: 'Dummy #g'>
	<description: 'Dummy #g with an icon provided by the current provider'>
	<iconSelector: #iconForG>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:48'!
h
	<gtExample>
	<label: 'Dummy #h'>
	<description: 'Dummy #h with an icon based on the given base64 string'>
	<iconBase64: 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAADrSURBVDjLY/z//z8DJYCJgUIw
yAwoPZHJBsS7STGABY1/9e+fvzKkGMAIiwWgzRfF2ST0/vz5w/Dw/UOGXz9/M/z6AcK/GH4C
MZj+jmCD5C70X2VkgWo+KcYqrqfArcTw598fBhluOTD9++9fIP7N8PsfEP/9AxUD0b8ZVq9c
i/AC0Nm//zD+Yfj19xdY0R+got9gxb8RNNQAkNyf/0CxX39QvZC5M+68MJuIAQczJ8PDlw8Z
Xr9/g9XZIK+BNP/5/Yfh/sJHjIzIKTF2VchNoEI5oAbHDWk7TpAcjUDNukDNB4nVjOKFEZwX
AOOhu7x6WtPJAAAAAElFTkSuQmCC'>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:50'!
i
	<gtExample>
	<label: 'Dummy #i'>
	<description: 'Dummy #i with an icon based on the given bytes'>
	<iconBytes: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:42'!
iconForG
	^ Smalltalk ui icons bookIcon! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 12:52'!
iconForJ
	^ Smalltalk ui icons bookIcon ! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:12'!
j
	<gtExample>
	<label: 'Dummy #i'>
	<description: 'Dummy #i with an icon based on the given bytes'>
	<iconClass: #GTDummyExamplesPragmas selector: #iconForJ>
! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:12'!
k
	<gtExample>
	<label: 'Dummy #k'>
	<description: 'Dummy #k, with subject Boolean (returns true)'>
	<subject: #Boolean>
	
	^ true & ( false == false ) | true | ( false ~= true )! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:12'!
l
	<gtExample>
	<label: 'Dummy #l'>
	<description: 'Dummy #l, with subjects Boolean and Number (returns true)'>
	<subject: #Boolean>
	<subject: #Number>
	
	^ true & ( 1 == 1 ) & (1 + 1 = 2)! !

!GTDummyExamplesPragmas class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 13:00'!
m
	<gtExample>
	<label: 'Dummy #m'>
	<description: 'Dummy #m, with subjects Boolean and Number (returns true)'>
	<subjectsAll: 'Boolean Number, Date . Duration ; Float'>
	
	^ true & ( 1 == 1 ) & ( Date today = Date today ) & ( Duration seconds: 0 ) isZero & Float pi isFloat! !

Object subclass: #GTDummyExamplesRecursive
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-1'!

!GTDummyExamplesRecursive class methodsFor: 'examples 1' stamp: 'StefanReichhart 9/26/2015 11:27'!
a: aBoolean
	<gtExample>
	<label: 'Dummy #a:, depends: #a:'>
	<depends: #a:> " loop "
	<noTest>
	
	^ aBoolean! !

!GTDummyExamplesRecursive class methodsFor: 'examples 1' stamp: 'StefanReichhart 9/26/2015 11:27'!
b: aBoolean
	<gtExample>
	<label: 'Dummy #b:, depends: #a:'>
	<depends: #a:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamplesRecursive class methodsFor: 'examples 1' stamp: 'StefanReichhart 9/26/2015 11:27'!
c: aBoolean
	<gtExample>
	<label: 'Dummy #c:, depends: #b:'>
	<depends: #b:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamplesRecursive class methodsFor: 'examples 2' stamp: 'StefanReichhart 9/26/2015 11:27'!
d: aBoolean
	<gtExample>
	<label: 'Dummy #d:, depends: #f:'>
	<depends: #f:> " loop "
	<noTest>
	
	^ aBoolean! !

!GTDummyExamplesRecursive class methodsFor: 'examples 2' stamp: 'StefanReichhart 9/26/2015 11:27'!
e: aBoolean
	<gtExample>
	<label: 'Dummy #e:, depends: #d:'>
	<depends: #d:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamplesRecursive class methodsFor: 'examples 2' stamp: 'StefanReichhart 9/26/2015 11:27'!
f: aBoolean
	<gtExample>
	<label: 'Dummy #f:, depends: #e:'>
	<depends: #e:>
	<noTest>
	
	^ aBoolean! !

!GTDummyExamplesRecursive class methodsFor: 'examples 3' stamp: 'StefanReichhart 9/26/2015 11:27'!
g: aBoolean1 g: aBoolean2
	<gtExample>
	<label: 'Dummy #g:g:, depends: #i:i: and #h'>
	<depends: #i:i:>
	<depends: #h>
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 3' stamp: 'StefanReichhart 9/26/2015 11:27'!
h
	<gtExample>
	<label: 'Dummy #h, (the only successful example in this example provider)'>
	<noTest>
	
	^ true! !

!GTDummyExamplesRecursive class methodsFor: 'examples 3' stamp: 'StefanReichhart 9/26/2015 11:27'!
i: aBoolean1 i: aBoolean2
	<gtExample>
	<label: 'Dummy #i:i:, depends: #j: and #h:'>
	<depends: #j:>
	<depends: #h>
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 3' stamp: 'StefanReichhart 9/26/2015 11:27'!
j: aBoolean1
	<gtExample>
	<label: 'Dummy #j:, depends: #g:'>
	<depends: #g:g:> " loop "
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 4' stamp: 'StefanReichhart 9/26/2015 11:28'!
k: aBoolean1 k: aBoolean2
	<gtExample>
	<label: 'Dummy #k:k:, depends: #m:m: and #l:l:'>
	<depends: #l:l:>
	<depends: #m:m:>
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 4' stamp: 'StefanReichhart 9/26/2015 11:28'!
l: aBoolean1 l: aBoolean2
	<gtExample>
	<label: 'Dummy #l:l:, depends: #k:k: and #n:'>
	<depends: #k:k:> " loop "
	<depends: #n:>
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 4' stamp: 'StefanReichhart 9/26/2015 11:28'!
m: aBoolean1 m: aBoolean2
	<gtExample>
	<label: 'Dummy #m:m:, depends: #l:l: and #n:'>
	<depends: #l:l:>
	<depends: #n:>
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 4' stamp: 'StefanReichhart 9/26/2015 11:28'!
n: aBoolean1
	<gtExample>
	<label: 'Dummy #n:, depends: #k:k:'>
	<depends: #k:k:> " loop "
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 5' stamp: 'StefanReichhart 9/26/2015 11:28'!
o: aBoolean1
	<gtExample>
	<label: 'Dummy #o:, depends: #p:'>
	<depends: #p:> 
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 5' stamp: 'StefanReichhart 9/26/2015 11:28'!
p: aBoolean1
	<gtExample>
	<label: 'Dummy #p:, depends: #o:'>
	<depends: #o:> " loop " 
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 6' stamp: 'StefanReichhart 9/26/2015 11:28'!
q: aBoolean1 q: aBoolean2
	<gtExample>
	<label: 'Dummy #q:q:, depends: #r: and #r:'>
	<depends: #r:> 
	<depends: #r:> 
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 6' stamp: 'StefanReichhart 9/26/2015 11:28'!
r: aBoolean1
	<gtExample>
	<label: 'Dummy #r:, depends: #s:'>
	<depends: #s:> 
	<noTest>
		
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 6' stamp: 'StefanReichhart 9/26/2015 11:29'!
s: aBoolean1
	<gtExample>
	<label: 'Dummy #s:, depends: #q:q:'>
	<depends: #q:q:> " loop " 
	<noTest>
		
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 9/26/2015 11:29'!
t: aBoolean1 t: aBoolean2
	<gtExample>
	<label: 'Dummy #t:t:, depends: #u:u: and #v:'>
	<depends: #u:u:> 
	<depends: #v:> 
	<noTest>
		
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 9/26/2015 11:29'!
u: aBoolean1 u: aBoolean2
	<gtExample>
	<label: 'Dummy #u:u:, depends: #v: and #w:w:'>
	<depends: #w:w:> 
	<depends: #v:> 
	<noTest>
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 9/26/2015 11:28'!
v: aBoolean1
	<gtExample>
	<label: 'Dummy #v:, depends: #x:'>
	<depends: #x:> 
	<noTest>
		
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 9/26/2015 11:28'!
w: aBoolean1 w: aBoolean2
	<gtExample>
	<label: 'Dummy #w:w:, depends: #x: and #y:'>
	<depends: #x:> 
	<depends: #y:> 
	<noTest>
		
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 9/26/2015 11:28'!
x: aBoolean1
	<gtExample>
	<label: 'Dummy #x:, depends: #y:'>
	<depends: #y:> 
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 9/26/2015 11:28'!
y: aBoolean1
	<gtExample>
	<label: 'Dummy #y:, depends: #z:'>
	<depends: #z:> 
	<noTest>
	
	^ aBoolean1! !

!GTDummyExamplesRecursive class methodsFor: 'examples 7' stamp: 'StefanReichhart 9/26/2015 11:28'!
z: aBoolean1
	<gtExample>
	<label: 'Dummy #z:, depends: #t:t:'>
	<depends: #t:t:>  " loop "
	<noTest>
	
	^ aBoolean1! !

Object subclass: #GTDummyExamplesWithAfter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-3'!

!GTDummyExamplesWithAfter class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/13/2016 21:02'!
a: b
	<gtExample>
	<depends: #b:>
	<after: #afterA>
	" START -> C -> afterC -> B -> afterB -> A -> afterA -> END "
	
	self assert: (self gtExampleContext includesKey: #c) not.
	self assert: (self gtExampleContext includesKey: #b) not.
	
	self assert: (self gtExampleContext includesKey: #c2).
	self assert: (self gtExampleContext includesKey: #b2).! !

!GTDummyExamplesWithAfter class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 3/28/2016 22:04'!
afterA
	self gtExampleContext removeKey: #b2.
	self gtExampleContext removeKey: #c2.
	
	self assert: self gtExampleContext isEmpty! !

!GTDummyExamplesWithAfter class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 3/28/2016 22:00'!
afterB
	self gtExampleContext removeKey: #b.! !

!GTDummyExamplesWithAfter class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 3/28/2016 21:59'!
afterC	
	self gtExampleContext removeKey: #c.! !

!GTDummyExamplesWithAfter class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/13/2016 21:01'!
b: c
	<gtExample>
	<depends: #c>
	<after: #afterB>
	" START -> C -> afterC -> B -> afterB -> END "
	
	self assert: (self gtExampleContext includesKey: #c) not.
	
	self gtExampleContext at: #b put: #b.
	self gtExampleContext at: #b2 put: #b2.
	
	self assert: ((self gtExampleContext at: #b) = #b).
	self assert: ((self gtExampleContext at: #b2) = #b2).
	
	^ #b2! !

!GTDummyExamplesWithAfter class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/13/2016 21:01'!
c
	<gtExample>
	<after: #afterC>
	" START -> C -> afterC -> END "
	
	self gtExampleContext at: #c put: #c.
	self gtExampleContext at: #c2 put: #c2.
	
	self assert: ((self gtExampleContext at: #c) = #c).
	self assert: ((self gtExampleContext at: #c2) = #c2).
	
	^ #c2! !

Object subclass: #GTDummyExamplesWithAfter2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-3'!

!GTDummyExamplesWithAfter2 class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/10/2016 17:24'!
afterB: a b: b b: c
	self assert: a notNil.
	self assert: a class = GTExample.
	
	self assert: b notNil.
	self assert: b == Smalltalk.
	
	self assert: c notNil.
	self assert: c = 2! !

!GTDummyExamplesWithAfter2 class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/10/2016 17:19'!
afterC: a c: b c: c
	self assert: a notNil.
	self assert: a class = GTExample.
	
	self assert: b notNil.
	self assert: b == Smalltalk.
	
	self assert: c notNil.
	self assert: c = 'abcd'.! !

!GTDummyExamplesWithAfter2 class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/10/2016 17:17'!
afterD: a d: b d: c
	self assert: a notNil.
	self assert: a class = Object.
	
	self assert: b notNil.
	self assert: b == Smalltalk.
	
	self assert: c notNil.
	self assert: c = 'abc'.! !

!GTDummyExamplesWithAfter2 class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/10/2016 18:24'!
b: argB
	<gtExample>
	<depends: #c:>
	<after: #afterB:b:b: arguments: #( varA varB argB )>
	| varA varB |
	
	self assert: argB = 2.
	
	varA := GTExample new.
	varB := Smalltalk.
	
	^ 3! !

!GTDummyExamplesWithAfter2 class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/10/2016 18:21'!
c: argC
	<gtExample>
	<depends: #d>
	<after: #afterC:c:c: arguments: #( varA varB varC )>
	| varA varB varC |
	
	self assert: argC = 1.
	
	varA := GTExample new.
	varB := Smalltalk.
	varC := 'abcd'.	
			
	^ 2! !

!GTDummyExamplesWithAfter2 class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/10/2016 18:16'!
d
	<gtExample>
	<after: #afterD:d:d: arguments: #( varA varB varC )>
	| varA varB varC |
	
	varA := Object new.
	varB := Smalltalk.
	varC := 'abc'.	
			
	^ 1! !

Object subclass: #GTDummyExamplesWithAfter2WithExceptions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-3'!

!GTDummyExamplesWithAfter2WithExceptions class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/10/2016 18:36'!
afterB: a b: b b: c
	self assert: a notNil.
	self assert: a class = GTExample.
	
	self assert: b notNil.
	self assert: b == Smalltalk.
	
	self assert: c notNil.
	self assert: c = 2! !

!GTDummyExamplesWithAfter2WithExceptions class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/10/2016 18:36'!
afterC: a c: b c: c
	self assert: a notNil.
	self assert: a class = GTExample.
	
	self assert: b notNil.
	self assert: b == Smalltalk.
	
	self assert: c notNil.
	self assert: c = 'abcd'.! !

!GTDummyExamplesWithAfter2WithExceptions class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/10/2016 18:36'!
afterD: a d: b d: c
	self assert: a notNil.
	self assert: a class = Object.
	
	self assert: b notNil.
	self assert: b == Smalltalk.
	
	self assert: c notNil.
	self assert: c = 'abc'.! !

!GTDummyExamplesWithAfter2WithExceptions class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/13/2016 21:04'!
b2: argB
	<gtExample>
	<depends: #c:>
	<after: #afterB:b: arguments: #( varA varB argB )> " mistake "
	<raises: #KeyNotFound> 
	" START -> D -> afterD:d:d: -> C -> afterC:c:c: -> B -> afterB:b: [ERROR] -> END "
	
	| varA varB |
	
	self assert: argB = 2.
	
	varA := GTExample new.
	varB := Smalltalk.
	
	^ 3! !

!GTDummyExamplesWithAfter2WithExceptions class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/13/2016 21:05'!
b3: argB
	<gtExample>
	<depends: #c:>
	<after: #afterB:b:b: arguments: #( varA varB varC )> " mistake "
	<raises: #AssertionFailure> " todo: THIS IS WRONG !! better: verify the static setup first "
	" START -> D -> afterD:d:d: -> C -> afterC:c:c: -> B -> afterB:b:b: -> END "
	
	| varA varB |
	
	self assert: argB = 2.
	
	varA := GTExample new.
	varB := Smalltalk.
	
	^ 3! !

!GTDummyExamplesWithAfter2WithExceptions class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/13/2016 21:03'!
c: argC
	<gtExample>
	<depends: #d>
	<after: #afterC:c:c: arguments: #( varA varB varC )>
	" START -> D -> afterD:d:d: -> C -> afterC:c:c: -> END "
	
	| varA varB varC |
	
	self assert: argC = 1.
	
	varA := GTExample new.
	varB := Smalltalk.
	varC := 'abcd'.	
			
	^ 2! !

!GTDummyExamplesWithAfter2WithExceptions class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/13/2016 21:02'!
d
	<gtExample>
	<after: #afterD:d:d: arguments: #( varA varB varC )>
	" START -> D -> afterD:d:d: -> END "
	
	| varA varB varC |
	
	varA := Object new.
	varB := Smalltalk.
	varC := 'abc'.	
			
	^ 1! !

Object subclass: #GTDummyExamplesWithAfterFinish
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-3'!

!GTDummyExamplesWithAfterFinish class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/13/2016 21:01'!
a: b
	<gtExample>
	<depends: #b:>
	<after: #afterA>
	<afterFinish: #afterAfinish>
	" START -> C -> afterC -> B -> afterB -> A -> afterA -> afterAfinish -> END "
	
	self assert: (self gtExampleContext includesKey: #c).
	self assert: (self gtExampleContext includesKey: #b).
	self assert: (self gtExampleContext includesKey: #a) not
	! !

!GTDummyExamplesWithAfterFinish class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/2/2016 19:22'!
afterA
	self gtExampleContext at: #a put: #a.! !

!GTDummyExamplesWithAfterFinish class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/2/2016 19:32'!
afterAfinish
	self assert: (self gtExampleContext includesKey: #a).
	self gtExampleContext removeKey: #a.
	self assert: (self gtExampleContext includesKey: #a) not.
	
	self assert: (self gtExampleContext includesKey: #b).
	self gtExampleContext removeKey: #b.
	self assert: (self gtExampleContext includesKey: #b) not.
	
	self assert: (self gtExampleContext includesKey: #c).
	self gtExampleContext removeKey: #c.
	self assert: (self gtExampleContext includesKey: #c) not.! !

!GTDummyExamplesWithAfterFinish class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/2/2016 19:15'!
afterB
	self gtExampleContext at: #b put: #b.! !

!GTDummyExamplesWithAfterFinish class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/2/2016 19:31'!
afterBfinish
	self assert: (self gtExampleContext includesKey: #b).
	self gtExampleContext removeKey: #b.
	self assert: (self gtExampleContext includesKey: #b) not.
	
	self assert: (self gtExampleContext includesKey: #c).
	self gtExampleContext removeKey: #c.
	self assert: (self gtExampleContext includesKey: #c) not.! !

!GTDummyExamplesWithAfterFinish class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/2/2016 19:16'!
afterC
	self gtExampleContext at: #c put: #c.! !

!GTDummyExamplesWithAfterFinish class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/2/2016 19:30'!
afterCfinish
	self assert: (self gtExampleContext includesKey: #c).
	self gtExampleContext removeKey: #c.
	self assert: (self gtExampleContext includesKey: #c) not.! !

!GTDummyExamplesWithAfterFinish class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/13/2016 21:01'!
b: c
	<gtExample>
	<depends: #c>
	<after: #afterB>
	<afterFinish: #afterBfinish>
	" START -> C -> afterC -> B -> afterB -> afterBfinish -> END "
	
	self assert: (self gtExampleContext includesKey: #c).
	self assert: (self gtExampleContext includesKey: #b) not! !

!GTDummyExamplesWithAfterFinish class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 4/13/2016 21:00'!
c
	<gtExample>
	<after: #afterC>
	<afterFinish: #afterCfinish>
	" START -> C -> afterC -> afterCfinish -> END "
	
	self assert: (self gtExampleContext includesKey: #c) not! !

Object subclass: #GTDummyExamplesWithContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-3'!

!GTDummyExamplesWithContext class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 3/28/2016 19:01'!
a
	<gtExample>
	self assert: self gtExampleContext notNil.
	self gtExampleContext at: #a put: #a.
	^ self gtExampleContext ! !

!GTDummyExamplesWithContext class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 3/28/2016 19:01'!
b: a c: c
	<gtExample>
	<depends: #a>
	<depends: #c>
	self assert: self gtExampleContext notNil.
	self assert: a == self gtExampleContext.
	self assert: c == self gtExampleContext.
	self assert: (self gtExampleContext at: #a) = #a.
	self assert: (self gtExampleContext at: #c) = #c.! !

!GTDummyExamplesWithContext class methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 3/28/2016 19:01'!
c
	<gtExample>
	self assert: self gtExampleContext notNil.
	self gtExampleContext at: #c put: #c.
	^ self gtExampleContext ! !

Object subclass: #GTDummyExamplesWithDependencies
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-1'!

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 13:03'!
a
	<gtExample>
	<label: 'Dummy #a'>
	<description: 'Dummy #a'>
	
	^ true! !

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 13:12'!
b: aBoolean
	<gtExample>
	<label: 'Dummy #b:'>
	<description: 'Dummy #b:, depends: #a'>
	<depends: #a> " aBoolean "
	
	^ aBoolean! !

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 13:12'!
c: aBoolean1 c: aBoolean2
	<gtExample>
	<label: 'Dummy #c:c:'>
	<description: 'Dummy #c:c:, depends: #a and #b:'>
	<depends: #a> " aBoolean1 "
	<depends: #b:> " aBoolean2 "
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 13:20'!
d: aBoolean1 d: aBoolean2 d: aBoolean3
	<gtExample>
	<label: 'Dummy #d:d:d:'>
	<description: 'Dummy #d:d:d:, depends: #a and #b: and #c:c:'>
	<depends: #a> " aBoolean1 "
	<depends: #b:> " aBoolean2 "
	<depends: #c:c:> " aBoolean3 "
	
	^ aBoolean1 & aBoolean2 & aBoolean3! !

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 13:11'!
e: aBoolean1 e: aBoolean2 e: aBoolean3 e: aBoolean4
	<gtExample>
	<label: 'Dummy #e:e:e:e:'>
	<description: 'Dummy #e:e:e:e:, depends: #a and #b: and #c:c: and #d:d:d:'>
	<depends: #a> " aBoolean1 "
	<depends: #b:> " aBoolean2 "
	<depends: #c:c:> " aBoolean3 "
	<depends: #d:d:d:> " aBoolean4 "
	
	^ aBoolean1 & aBoolean2 & aBoolean3 & aBoolean4! !

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 13:11'!
f: aBoolean1 f: aBoolean2 f: aBoolean3
	" to have the same dependency more than once probably makes no sense at all, but it is technically valid. We don't make any constraints "
	<gtExample>
	<label: 'Dummy #f:f:f:'>
	<description: 'Dummy #f:f:f:, depends: #a and #a and #a'>
	<depends: #a> " aBoolean1 "
	<depends: #a> " aBoolean2 "
	<depends: #a> " aBoolean3 "
	
	^ aBoolean1 & aBoolean2 & aBoolean3! !

!GTDummyExamplesWithDependencies class methodsFor: 'examples' stamp: 'StefanReichhart 9/12/2015 13:11'!
g: aBoolean1 g: aBoolean2 g: aBoolean3
	<gtExample>
	<label: 'Dummy #g:g:g:'>
	<description: 'Dummy #g:g:g:, depends: #a and #e:e:e:e: and #d:d:d:'>
	<depends: #a> " aBoolean1 "
	<depends: #e:e:e:e:> " aBoolean2 "
	<depends: #d:d:d:> " aBoolean3 "
	
	^ aBoolean1 & aBoolean2 & aBoolean3! !

Object subclass: #GTDummyExamplesWithExceptions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-1'!

!GTDummyExamplesWithExceptions class methodsFor: 'examples 1' stamp: 'AndreiChis 12/4/2015 15:13'!
a
	<gtExample>
	<label: 'Dummy #a'>
	<description: 'Dummy #a, raises ZeroDivide'>
	<raises: #ZeroDivide>
	
	^ 1/0! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 1' stamp: 'StefanReichhart 9/12/2015 13:45'!
b
	<gtExample>
	<label: 'Dummy #b'>
	<description: 'Dummy #b, raises ZeroDivide'>
	<raises: #ZeroDivide>
	
	^ 1/0! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 1' stamp: 'StefanReichhart 9/12/2015 13:45'!
c
	<gtExample>
	<label: 'Dummy #c'>
	<description: 'Dummy #c, raises ZeroDivide'>
	<raises: 'ZeroDivide'>
	
	^ 1/0! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 2' stamp: 'AndreiChis 12/4/2015 15:13'!
d
	<gtExample>
	<label: 'Dummy #d'>
	<description: 'Dummy #d, raises ZeroDivide or AssertionFailure'>
	<raises: #ZeroDivide>
	<raises: #AssertionFailure>
	
	self assert: #( true false ) atRandom.
	^ 1/0! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 3' stamp: 'StefanReichhart 9/26/2015 11:26'!
e
	<gtExample>
	<label: 'Dummy #e'>
	<description: 'Dummy #e, raises an unexpected exception (AssertionFailure) since we did not a declare it'>
	<noTest>
	
	self assert: false! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 3' stamp: 'StefanReichhart 9/12/2015 14:01'!
f: anObject
	<gtExample>
	<label: 'Dummy #f'>
	<description: 'Dummy #f, depends: #b which raises an expected exception, returns nil'>
	<depends: #b>
	
	self assert: anObject isNil! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 3' stamp: 'StefanReichhart 9/26/2015 11:26'!
g: anObject
	<gtExample>
	<label: 'Dummy #g'>
	<description: 'Dummy #g, depends: #e, should raise a dependency error since the only dependency is raising an exception'>
	<depends: #e>
	<noTest>
	
	^ anObject! !

!GTDummyExamplesWithExceptions class methodsFor: 'examples 3' stamp: 'AndreiChis 12/4/2015 15:14'!
h
	<gtExample>
	<label: 'Dummy #h'>
	<description: 'Dummy #h, should raise an exception (by declaration) but it does not'>
	<raises: #AssertionFailure>
	<raises: #ZeroDivide>
	<noTest>
	
	self assert: true. " no exception raised -> expected exception not raises"
	true " no exception raised -> expected exception not raises "
		ifTrue: [ ^ 1 ] 
		ifFalse: [ 1/0 ]! !

Object subclass: #GTDummyExamplesWithExternalDependencies
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-1'!

!GTDummyExamplesWithExternalDependencies class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:14'!
a: aBoolean
	<gtExample>
	<label: 'Dummy #a:'>
	<description: 'Dummy #a:, depends: GTDummyExamples>>#a'>
	<dependsClass: #GTDummyExamples selector: #a> 
	
	^ aBoolean! !

!GTDummyExamplesWithExternalDependencies class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:14'!
b: aBoolean1 b: aBoolean2
	<gtExample>
	<label: 'Dummy #b:b:'>
	<description: 'Dummy #b:b:, depends: GTDummyExamples>>#a and GTDummyExamples>>#b:'>
	<dependsClass: #GTDummyExamples selector: #a> 
	<dependsClass: #GTDummyExamples selector: #b:> 
	
	^ aBoolean1 & aBoolean2! !

!GTDummyExamplesWithExternalDependencies class methodsFor: 'examples' stamp: 'AndreiChis 12/4/2015 15:14'!
c: aBoolean1 c: aBoolean2 c: aBoolean3
	<gtExample>
	<label: 'Dummy #c:c:'>
	<description: 'Dummy #c:c:c:, depends: GTDummyExamples>>#a and GTDummyExamples>>#b: and GTDummyExamplesWithDependencies>>#a'>
	<dependsClass: #GTDummyExamples selector: #a> 
	<dependsClass: #GTDummyExamples selector: #b:> 
	<dependsClass: 'GTDummyExamplesWithDependencies' selector: #a>
	
	^ aBoolean1 & aBoolean2 & aBoolean3! !

TestCase subclass: #GTDummyExampleWithAssertions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Set-2'!

!GTDummyExampleWithAssertions class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/12/2015 09:48'!
gtExamplesProvider
	^ self new! !

!GTDummyExampleWithAssertions methodsFor: 'examples' stamp: 'AndreiChis 10/15/2015 11:59'!
a
	<gtExample>
	^ true! !

!GTDummyExampleWithAssertions methodsFor: 'examples' stamp: 'AliakseiSyrel 10/12/2015 09:48'!
b
	<gtExample>
	^ true! !

!GTDummyExampleWithAssertions methodsFor: 'examples' stamp: 'StefanReichhart 10/13/2015 20:49'!
c: aBoolean c: anotherBoolean
	<gtExample>
	<depends: #a>
	<depends: #b>
	self assert: aBoolean equals: anotherBoolean.
	^ aBoolean & anotherBoolean! !

TestCase subclass: #GTInspectorDummyExamplesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Dummies-Tests'!

!GTInspectorDummyExamplesTest methodsFor: 'accessing' stamp: 'StefanReichhart 9/12/2015 17:38'!
allExamplesDummiesProviders
	^ { 
		GTDummyExamples. 
		GTDummyExamplesPragmas. 
		GTDummyExamplesRecursive. 
		GTDummyExamplesWithDependencies. 
		GTDummyExamplesWithExternalDependencies.
		GTDummyExamplesWithExceptions 
	}! !

!GTInspectorDummyExamplesTest methodsFor: 'utils' stamp: 'StefanReichhart 9/12/2015 14:22'!
examplesInClasses: aSelector do: aBlock
	| classes examples |
	self shouldnt: [ classes  := (self perform: aSelector) ] raise: Error.
	classes do: [ :each |
		self shouldnt: [ examples := each gtExamples ] raise: Error.
		examples do: [ :example |
			self shouldnt: [ aBlock value: example ] raise: Error ] ]! !

!GTInspectorDummyExamplesTest methodsFor: 'accessing' stamp: 'StefanReichhart 9/12/2015 14:36'!
invalidExamplesDummiesProviders
	^ { 
		GTDummyExamplesInvalid.
	}! !

!GTInspectorDummyExamplesTest methodsFor: 'accessing' stamp: 'StefanReichhart 9/12/2015 14:41'!
recursiveExamplesDummiesProviders
	^ { 
		GTDummyExamplesRecursive.
	}! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testExists
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: example exists ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:36'!
testInvalidDefinitions
	self examplesInClasses: #invalidExamplesDummiesProviders do: [ :example | 
		self assert: example exists.
		self deny: example isValid ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testIsEquals
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: (example = example) ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testIsGTExample
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: example isGTExample ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testMatchesMethod
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self assert: (example matchesMethod: example method) ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:40'!
testRecursiveDefinitions
	self examplesInClasses: #recursiveExamplesDummiesProviders do: [ :example | 
		self assert: example exists.
		self assert: example hasValidArguments.
		self assert: example hasValidDependencies.
		self assert: (example method selector = #h or: [ example isValid not ]) ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testResult
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self shouldnt: [ example result ] raise: Error.
		self shouldnt: [ example returnValue ] raise: Error.
		self shouldnt: [ example detachResultFromSystem ] raise: Error.
		self shouldnt: [ example result ] raise: Error.
		self shouldnt: [ example returnValue ] raise: Error. ]! !

!GTInspectorDummyExamplesTest methodsFor: 'tests' stamp: 'StefanReichhart 9/12/2015 14:26'!
testRun
	self examplesInClasses: #allExamplesDummiesProviders do: [ :example | 
		self shouldnt: [ example run ] raise: Error ]! !
